###
### SSNTaleomE_01.tcl
###
### by zhuo
### Rev.0.1. 2015.04.01



text .screen -font "Mincho 12" -width 80 -height 25 -bg "\#406040" -fg "\#50b020"
pack .screen
wm focusmodel . active
wm deiconify .
focus -force .screen
bind . <KeyPress-Return> { processInputString; break }


proc print { line args } {
    set idx end
    foreach arg $args {
	set idx $arg
	break
    }    
    .screen insert $idx "$line"
    .screen delete 0.0 "end - 25 lines"
    .screen mark set insert end
    update
    after 80
}

set ::filename "SSN00000.txt"
array set ::entry {
    Date ""
    SoftwareName ""
    Author ""
    LinkTitles ""
    LinkURLs ""
    LinkTexts ""
    LinkTails ""
    Summary ""
    Citation ""
    Descriptions ""
}

proc resetEntry {} {
    set ::entry(Date) "" 
    set ::entry(SoftwareName) "" 
    set ::entry(Author) "" 
    set ::entry(LinkTitles) "" 
    set ::entry(LinkURLs) "" 
    set ::entry(LinkTexts) "" 
    set ::entry(LinkTails) "" 
    set ::entry(Summary) "" 
    set ::entry(Citation) "" 
    set ::entry(Descriptions) "" 
}

proc  processInputString {} {
    # remove  entered "Return" char
    .screen delete "insert - 1 chars"
    set str [.screen get "insert linestart" "insert lineend"]
    print "\n"
#    puts $str
    # PROESS
    switch $::state {
	MAIN {
	    switch $str {
		1 {
		    print "t:\n"
		    print "$::entry(Date)"
		    set ::state DATE_INPUT
		}
		2 {
		    print "\tgEFA:\n"
		    print "$::entry(SoftwareName)"
		    set ::state SOFTNAME_INPUT
		}
		3 {
		    print "Җ:\n"
		    print "$::entry(Author)"
		    set ::state AUTHOR_INPUT
		}
		4 {
		    print "N^Cg(TAB؂ŕw):\n"
		    print "$::entry(LinkTitles)"
		    set ::state LINK_TITLES_INPUT
		}
		5 {
		    print "NURL(TAB؂ŕw):\n"
		    print "$::entry(LinkURLs)"
		    set ::state LINK_URLS_INPUT
		}
		6 {
		    print "NeLXg(TAB؂ŕw):\n"
		    print "$::entry(LinkTexts)"
		    set ::state LINK_TEXTS_INPUT
		}
		7 {
		    print "N(TAB؂ŕw):\n"
		    print "$::entry(LinkTails)"
		    set ::state LINK_TAILS_INPUT
		}
		8 {
		    print ":\n"
		    print "$::entry(Summary)"
		    set ::state SUMMARY_INPUT
		}
		9 {
		    print "p:\n"
		    print "$::entry(Citation)"
		    set ::state CITATION_INPUT
		}
		A - a {
		    print "tL(TAB؂ŕsw):\n"
		    print "$::entry(Descriptions)"
		    set ::state DESCRIPTIONS_INPUT
		}
		B - b {
		    print "Z[u:t@C\n"
		    print "$::filename"
		    set ::state SAVEFILE_INPUT
		}
		C - c {
		    print "[h:t@C\n"
		    print "$::filename"
		    set ::state LOADFILE_INPUT
		}
		D - d {
		    print "Gg[f[^:\n"
		    print "t@@@@@@$::entry(Date)\n"
		    print "\tgEFA@$::entry(SoftwareName)\n"
		    print "Җ@@@@@$::entry(Author)\n"
		    print "N^Cg@$::entry(LinkTitles)\n"
		    print "NURL @@@$::entry(LinkURLs)\n"
		    print "NeLXg@$::entry(LinkTexts)\n"
		    print "N@$::entry(LinkTails)\n"
		    print "@@@@@$::entry(Summary)\n"
		    print "p@@@@@@$::entry(Citation)\n"
		    print "tL@@@@@@$::entry(Descriptions)\n"
		    print "*** sŃR}h͂ɖ߂ ***\n"
		    set ::state WAIT_CR
		}
		E - e {
		    destroy .
		}
	    }
	}
	DATE_INPUT {
	    set ::entry(Date) $str
	    set ::state MAIN
	}
	SOFTNAME_INPUT {
	    set ::entry(SoftwareName) $str
	    set ::state MAIN
	}
	AUTHOR_INPUT {
	    set ::entry(Author) $str
	    set ::state MAIN
	}
	LINK_TITLES_INPUT {
	    set ::entry(LinkTitles) $str
	    set ::state MAIN
	}
	LINK_URLS_INPUT {
	    set ::entry(LinkURLs) $str
	    set ::state MAIN
	}
	LINK_TEXTS_INPUT {
	    set ::entry(LinkTexts) $str
	    set ::state MAIN
	}
	LINK_TAILS_INPUT {
	    set ::entry(LinkTails) $str
	    set ::state MAIN
	}
	SUMMARY_INPUT {
	    set ::entry(Summary) $str
	    set ::state MAIN
	}
	CITATION_INPUT {
	    set ::entry(Citation) $str
	    set ::state MAIN
	}
	DESCRIPTIONS_INPUT {
	    set ::entry(Descriptions) $str
	    set ::state MAIN
	}
	SAVEFILE_INPUT {
	    set ::filename $str
	    set fd [open $::filename "w"]
	    puts $fd "SSN TALECOM-E	0.1"
	    puts $fd "$::entry(Date)"
	    puts $fd "$::entry(SoftwareName)"
	    puts $fd "$::entry(Author)"
	    puts $fd "$::entry(LinkTitles)"
	    puts $fd "$::entry(LinkURLs)"
	    puts $fd "$::entry(LinkTexts)"
	    puts $fd "$::entry(LinkTails)"
	    puts $fd "$::entry(Summary)"
	    puts $fd "$::entry(Citation)"
	    puts $fd "$::entry(Descriptions)"
	    close $fd
	    set ::state MAIN
	}
	LOADFILE_INPUT {
	    set fd ""
	    if [catch {set fd [open $str "r"]}] {
		print "$str: FILE NOT FOUND\n" 
	    } else {
		set ::filename $str
		gets $fd versionline
		set words [split $versionline "\t"]
		if { [lindex $words 0] != "SSN TALECOM-E" || [lindex $words 1] != "0.1" } {
		    print "$versionline: DATA NOT READABLE\n"
		} else {
		    gets $fd ::entry(Date)
		    gets $fd ::entry(SoftwareName)
		    gets $fd ::entry(Author)
		    gets $fd ::entry(LinkTitles)
		    gets $fd ::entry(LinkURLs)
		    gets $fd ::entry(LinkTexts)
		    gets $fd ::entry(LinkTails)
		    gets $fd ::entry(Summary)
		    gets $fd ::entry(Citation)
		    gets $fd ::entry(Descriptions)
		}
		close $fd
	    }
	    set ::state MAIN
	}
	WAIT_CR {
	    set ::state MAIN
	}
	default {
	    set ::state MAIN
	}
    }
    switch $::state {
	MAIN {
	    print "******************* R}h ******************\n"
	    print "1 t͂\n"
	    print "2 \tgEFA͂\n"
	    print "3 Җ͂\n"
	    print "4 N^Cg͂(TAB؂ŕw)\n"
	    print "5 NURL͂(TAB؂ŕw)\n"
	    print "6 NeLXg͂(TAB؂ŕw)\n"
	    print "7 N͂(TAB؂ŕw)\n"
	    print "8 ͂\n"
	    print "9 p͂\n"
	    print "A tL͂(TAB؂ŕsw)\n"
	    print "B Gg[f[^Z[u\n"
	    print "C Gg[f[^[h\n"
	    print "D Gg[f[^\\n"
	    print "E I\n"
	    print "***********************************************\n"
	}
    }
}


print "***********************************************\n"
print "*  S S N   T A L E C O M - E   S Y S T E M    *\n"
print "*  VER. 0.1  APRIL 1 2015                     *\n"
print "*  BY ZHUO                                    *\n"
print "***********************************************\n"
set ::state INIT
resetEntry
processInputString
